<script>
	import Fuse from 'fuse.js'
	let fuse = new Fuse([], {})

	let searchQuery = ""
	let data = []

	fetch('https://cdn.jsdelivr.net/npm/country-flag-emoji-json@2.0.0/dist/index.json')
	.then(res => res.json())
	.then(json => data = json)
	.then(() => fuse = new Fuse(data, {
		// More available settings: https://fusejs.io/api/options.html
		includeScore: true,
		keys: ['name']
	}))
</script>

<main>
	<input type="search" placeholder="Search..." bind:value={searchQuery}>
	{#if searchQuery}
		{#each fuse.search(searchQuery) as result }
			<section>
				<span><img src={result.item.image} alt={result.item.emoji}/> {result.item.name}</span>
				<span style="opacity: 0.5">{(1 - result.score).toFixed(2)}</span>
			</section>
		{/each}
	{:else}
		<center>
			<span>Please search for a country name above</span>
		</center>
	{/if}
</main>

<style>
	main {
		padding: 2em;
		max-width: 23em;
		margin: 0 auto;
	}
	input {
		margin-left: -1em;
		width: 25em;
		z-index: 1;
	}
	img { height: 1em }

	section {
		display: flex;
		justify-content: space-between;
	}

	@media (max-width: 640px) {
		main { max-width: none }
		input {
			width: calc(100vw - 3em);
			position: absolute;
			bottom: 1em
		}
	}
</style>